#define DatasteadFilterName "Datastead RTSP/RTMP/HTTP/ONVIF Source"

#define EC_RTSPNOTIFY EC_USER + 0x4000
#define EC_RTSP_PARAM1_DISKFULL                        1
#define EC_RTSP_PARAM1_DEVICELOST_RECONNECTING         3
#define EC_RTSP_PARAM1_DEVICELOST_RECONNECTED          4
#define EC_RTSP_PARAM1_RECORDTONEWFILE_COMPLETED       5
#define EC_RTSP_PARAM1_OPENURLASYNC_CONNECTION_RESULT  6
#define EC_RTSP_PARAM1_FRAME_CAPTURE_SUCCEEDED         7
#define EC_RTSP_PARAM1_FRAME_CAPTURE_FAILED            8
#define EC_RTSP_PARAM1_ONVIF_SNAPSHOT_SUCCEEDED        9
#define EC_RTSP_PARAM1_ONVIF_SNAPSHOT_FAILED          10
#define EC_RTSP_DURATION_UPDATED                      11

//_________________________________________________________________________________
// {55D1139D-5E0D-4123-9AED-575D7B039569}
static const GUID CLSID_DatasteadRtspRtmpHttpONVIFSource = 
{ 0x55D1139D, 0x5E0D, 0x4123, { 0x9A, 0xED, 0x57, 0x5D, 0x7B, 0x03, 0x95, 0x69 } };

//_________________________________________________________________________________
// {C7CC1A23-8B8A-4BFD-A96C-B5E735E055BA}
static const GUID DatasteadVideoRenderer = 
{ 0xC7CC1A23, 0x8B8A, 0x4BFD, { 0xA9, 0x6C, 0xB5, 0xE7, 0x35, 0xE0, 0x55, 0xBA } };
// the Datastead Video Renderer supports the screen locking (Ctrl+Alt+Del)

//_________________________________________________________________________________
// {D7557B82-3FA4-4F4F-B7CF-96108202E4AF}
static const GUID IID_IDatasteadRTSPSourceConfig = 
{ 0xd7557b82, 0x3fa4, 0x4f4f, { 0xb7, 0xcf, 0x96, 0x10, 0x82, 0x2, 0xe4, 0xaf } };

MIDL_INTERFACE("D7557B82-3FA4-4F4F-B7CF-96108202E4AF")
IDatasteadRTSPSourceConfig : public IUnknown
{
    virtual HRESULT STDMETHODCALLTYPE GetBool   (LPCOLESTR ParamID,      bool  *Value) = 0; 
    virtual HRESULT STDMETHODCALLTYPE GetDouble (LPCOLESTR ParamID,    double  *Value) = 0;
    virtual HRESULT STDMETHODCALLTYPE GetInt    (LPCOLESTR ParamID,       int  *Value) = 0;
    virtual HRESULT STDMETHODCALLTYPE GetStr    (LPCOLESTR ParamID,  LPOLESTR  *Value) = 0; 

    virtual HRESULT STDMETHODCALLTYPE SetBool   (LPCOLESTR ParamID,       bool  Value) = 0;
    virtual HRESULT STDMETHODCALLTYPE SetDouble (LPCOLESTR ParamID,     double  Value) = 0;
    virtual HRESULT STDMETHODCALLTYPE SetInt    (LPCOLESTR ParamID,        int  Value) = 0;
    virtual HRESULT STDMETHODCALLTYPE SetStr    (LPCOLESTR ParamID,  LPCOLESTR  Value) = 0;

    virtual HRESULT STDMETHODCALLTYPE Action    (LPCOLESTR ActionID, LPCOLESTR Option) = 0;
};

//_________________________________________________________________________________
// {932C369A-3335-45BB-B5F4-A6CF77F9B40C}
static const GUID IID_IDatasteadRTSPSourceConfig2 =
{ 0x932c369a, 0x3335, 0x45bb,{ 0xb5, 0xf4, 0xa6, 0xcf, 0x77, 0xf9, 0xb4, 0xc } };

MIDL_INTERFACE("932C369A-3335-45BB-B5F4-A6CF77F9B40C")
IDatasteadRTSPSourceConfig2 : public IDatasteadRTSPSourceConfig
{
	virtual HRESULT STDMETHODCALLTYPE GetIntPtr(LPCOLESTR ParamID, intptr_t  *Value) = 0;
};

// {6FCA28BE-7F96-467A-BB08-0611FC8162B7}
static const GUID IID_IDatasteadRTSPSourceConfig3 =
{ 0x6fca28be, 0x7f96, 0x467a,{ 0xbb, 0x8, 0x6, 0x11, 0xfc, 0x81, 0x62, 0xb7 } };

MIDL_INTERFACE("6FCA28BE-7F96-467A-BB08-0611FC8162B7")
IDatasteadRTSPSourceConfig3 : public IDatasteadRTSPSourceConfig2
{
	virtual HRESULT STDMETHODCALLTYPE GetInt64(LPCOLESTR ParamID, __int64  *Value) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetInt64(LPCOLESTR ParamID, __int64  Value) = 0;
};

//_________________________________________________________________________________
// current state: returned by DatasteadRTSPSourceConfig.GetInt (RTSP_Source_GetState_int)
//_________________________________________________________________________________

typedef enum TSourceState { state_disconnected, state_connecting_async, state_connecting_sync, state_reconnecting, state_connected, state_previewing, state_recording_paused, state_recording_active };

//_________________________________________________________________________________
// Filter configuration identifiers that are supported as ParamID by the IDatasteadRTSPSourceConfig functions
//_________________________________________________________________________________

#define RTSP_Action_OpenURL                             L"RTSP_Action_OpenURL"
#define RTSP_Action_OpenURLAsync                        L"RTSP_Action_OpenURLAsync"
#define RTSP_Action_GetONVIFSnapshot                    L"RTSP_Action_GetONVIFSnapshot"
#define RTSP_Action_GetONVIFSnapshotAsync               L"RTSP_Action_GetONVIFSnapshotAsync"
#define RTSP_Action_RecordToNewFileNow                  L"RTSP_Action_RecordToNewFileNow"
#define RTSP_Action_CancelPendingConnection             L"RTSP_Action_CancelPendingConnection"
#define RTSP_Action_PauseURL                            L"RTSP_Action_PauseURL"
#define RTSP_Action_ResumeURL                           L"RTSP_Action_ResumeURL"
#define RTSP_Action_PauseRecording                      L"RTSP_Action_PauseRecording"
#define RTSP_Action_ResumeRecording                     L"RTSP_Action_ResumeRecording"
#define RTSP_Action_CaptureFrame                        L"RTSP_Action_CaptureFrame"
#define RTSP_Action_UpdateDuration                      L"RTSP_Action_UpdateDuration"

#define RTSP_Source_RecordingFileName_str               L"RTSP_Source_RecordingFileName_str" 
#define RTSP_Source_RecordingBacktimedStartSeconds_int  L"RTSP_Source_RecordingBacktimedStartSeconds_int" 
#define RTSP_Source_Recording_Title_str					L"RTSP_Source_Recording_Title_str" 
#define RTSP_Source_PlayableWhileRecording_int          L"RTSP_Source_PlayableWhileRecording_int" 
#define RTSP_Source_ContinuousRecording_bool			L"RTSP_Source_ContinuousRecording_bool" 
#define RTSP_Source_MaxAnalyzeDuration_int              L"RTSP_Source_MaxAnalyzeDuration_int"
#define RTSP_Source_AutoReconnect_bool                  L"RTSP_Source_AutoReconnect_bool"
#define RTSP_Source_NoTranscoding_bool                  L"RTSP_Source_NoTranscoding_bool"
#define RTSP_Source_DeviceLostTimeOut_int               L"RTSP_Source_DeviceLostTimeOut_int"
#define RTSP_Source_BufferDuration_int                  L"RTSP_Source_BufferDuration_int" 
#define RTSP_Source_LowDelay_int                        L"RTSP_Source_LowDelay_int" 
#define RTSP_Source_SampleDeliveryMode_int              L"RTSP_Source_SampleDeliveryMode_int"
#define RTSP_Source_ConnectionTimeOut_int               L"RTSP_Source_ConnectionTimeOut_int"
#define RTSP_Source_RTSPTransport_int                   L"RTSP_Source_RTSPTransport_int"
#define RTSP_Source_RTSPRange_str						L"RTSP_Source_RTSPRange_str"
#define RTSP_Source_Format_str                          L"RTSP_Source_Format_str"
#define RTSP_Source_FrameRate_double                    L"RTSP_Source_FrameRate_double"
#define RTSP_Source_AverageTimePerFrame100ns_int        L"RTSP_Source_AverageTimePerFrame100ns_int"
#define RTSP_Source_DurationMs_int					    L"RTSP_Source_DurationMs_int" 
#define RTSP_Source_Duration100ns_int64					L"RTSP_Source_Duration100ns_int64" 
#define RTSP_Source_VideoSize_str						L"RTSP_Source_VideoSize_str"
#define RTSP_Source_VideoCodec_str						L"RTSP_Source_VideoCodec_str"
#define RTSP_Source_AuthUser_str                        L"RTSP_Source_AuthUser_str" 
#define RTSP_Source_AuthPassword_str                    L"RTSP_Source_AuthPassword_str" 
#define RTSP_Source_StreamInfo_str                      L"RTSP_Source_StreamInfo_str"
#define RTSP_Source_StartTime_int                       L"RTSP_Source_StartTime_int"
#define RTSP_Source_Threads_int                         L"RTSP_Source_Threads_int"
#define RTSP_Source_IsURLConnected_bool                 L"RTSP_Source_IsURLConnected_bool"
#define RTSP_Source_GetAudioDevices_str                 L"RTSP_Source_GetAudioDevices_str"
#define RTSP_Source_SetAudioDevice_str                  L"RTSP_Source_SetAudioDevice_str"
#define RTSP_Source_GetURL_str							L"RTSP_Source_GetURL_str" 
#define RTSP_Source_GetState_int						L"RTSP_Source_GetState_int" 

#define RTSP_ONVIF_LastJPEGSnapshotBuffer_intptr        L"RTSP_ONVIF_LastJPEGSnapshotBuffer_intptr"
#define RTSP_ONVIF_LastJPEGSnapshotSize_int             L"RTSP_ONVIF_LastJPEGSnapshotSize_int"

#define RTSP_VideoStream_Enabled_bool                   L"RTSP_VideoStream_Enabled_bool" 
#define RTSP_VideoStream_Synchronized_bool              L"RTSP_VideoStream_Synchronized_bool" 
#define RTSP_VideoStream_Recorded_bool                  L"RTSP_VideoStream_Recorded_bool"
#define RTSP_VideoStream_Index_int                      L"RTSP_VideoStream_Index_int" 
#define RTSP_VideoStream_PinFormat_str                  L"RTSP_VideoStream_PinFormat_str" 
#define RTSP_VideoStream_Width_int                      L"RTSP_VideoStream_Width_int" 
#define RTSP_VideoStream_Height_int                     L"RTSP_VideoStream_Height_int" 
#define RTSP_VideoStream_AspectRatio_double             L"RTSP_VideoStream_AspectRatio_double" 
#define RTSP_VideoStream_TopDown_bool                   L"RTSP_VideoStream_TopDown_bool" 
#define RTSP_VideoStream_FrameRateMax_double            L"RTSP_VideoStream_FrameRateMax_double"
#define RTSP_VideoStream_Filter_str                     L"RTSP_VideoStream_Filter_str" 
#define RTSP_VideoStream_HWAcceleration_int             L"RTSP_VideoStream_HWAcceleration_int"
#define RTSP_VideoStream_Deinterlacing_int              L"RTSP_VideoStream_Deinterlacing_int"
#define RTSP_VideoStream_ConfigureTextOverlay_str       L"RTSP_VideoStream_ConfigureTextOverlay_str"
#define RTSP_VideoStream_ConfigureHueBrightSat_str		L"RTSP_VideoStream_ConfigureHueBrightSat_str"

#define RTSP_AudioStream_Enabled_bool                   L"RTSP_AudioStream_Enabled_bool"
#define RTSP_AudioStream_Recorded_bool                  L"RTSP_AudioStream_Recorded_bool"
#define RTSP_AudioStream_Index_int                      L"RTSP_AudioStream_Index_int"
#define RTSP_AudioStream_Filter_str                     L"RTSP_AudioStream_Filter_str" 
#define RTSP_AudioStream_Volume_int                     L"RTSP_AudioStream_Volume_int"

#define RTSP_FrameCapture_Width_int                     L"RTSP_FrameCapture_Width_int"
#define RTSP_FrameCapture_Height_int                    L"RTSP_FrameCapture_Height_int"
#define RTSP_FrameCapture_Time_int                      L"RTSP_FrameCapture_Time_int"
#define RTSP_FrameCapture_FileName_str                  L"RTSP_FrameCapture_FileName_str"

#define RTSP_CurrentRecording_FileSizeKb_int            L"RTSP_CurrentRecording_FileSizeKb_int"
#define RTSP_CurrentRecording_ClipDurationMs_int        L"RTSP_CurrentRecording_ClipDurationMs_int"
#define RTSP_CurrentRecording_VideoFrameCount_int       L"RTSP_CurrentRecording_VideoFrameCount_int"
#define RTSP_CurrentRecording_FileName_str              L"RTSP_CurrentRecording_FileName_str"

#define RTSP_LastRecorded_FileSizeKb_int                L"RTSP_LastRecorded_FileSizeKb_int"
#define RTSP_LastRecorded_ClipDurationMs_int            L"RTSP_LastRecorded_ClipDurationMs_int"
#define RTSP_LastRecorded_VideoFrameCount_int           L"RTSP_LastRecorded_VideoFrameCount_int"
#define RTSP_LastRecorded_FileName_str                  L"RTSP_LastRecorded_FileName_str"

#define RTSP_Dest_URL_str                               L"RTSP_Dest_URL_str"
#define RTSP_Dest_Video_BitRate_int                     L"RTSP_Dest_Video_BitRate_int"
#define RTSP_Dest_Video_Quality_int                     L"RTSP_Dest_Video_Quality_int"
#define RTSP_Dest_Video_KeyFrameInterval_int            L"RTSP_Dest_Video_KeyFrameInterval_int"

#define RTSP_Filter_Version_int                         L"RTSP_Filter_Version_int"
#define RTSP_Filter_Build_int                           L"RTSP_Filter_Build_int"
#define RTSP_Filter_LicenseKey_str                      L"RTSP_Filter_LicenseKey_str"

//_________________________________________________________________________________
// {58D66E77-B19C-4F9A-8B47-DFE1CA87B642}
static const GUID IID_IDatasteadRTSPSourceCallbackConfig =
{ 0x58d66e77, 0xb19c, 0x4f9a, { 0x8b, 0x47, 0xdf, 0xe1, 0xca, 0x87, 0xb6, 0x42 } };

typedef void (__stdcall *OpenURLAsyncCompletionCB) (void *Sender, intptr_t CustomParam, HRESULT Result); 

MIDL_INTERFACE("58D66E77-B19C-4F9A-8B47-DFE1CA87B642")
IDatasteadRTSPSourceCallbackConfig : public IUnknown
{
    virtual HRESULT STDMETHODCALLTYPE SetAsyncOpenURLCallback (OpenURLAsyncCompletionCB CallbackFunctionPtr, void *Sender, intptr_t CustomParam) = 0;
};

//_________________________________________________________________________________

typedef void (__stdcall *DatasteadRTSP_RawSampleCallback) (void *Sender, int StreamNumber, char *CodecName, __int64 SampleTime_Absolute, __int64 SampleTime_Relative, BYTE *Buffer, int BufferSize, char *InfoString);
typedef void (__stdcall *DatasteadRTSP_VideoSampleCallback) (void *Sender, __int64 SampleTime_Absolute, __int64 SampleTime_Relative, BYTE *Buffer, int BufferSize, int VideoWidth, int VideoHeight, int BitCount, int Stride); 
typedef void (__stdcall *DatasteadRTSP_AudioSampleCallback) (void *Sender, __int64 SampleTime_Absolute, __int64 SampleTime_Relative, BYTE *Buffer, int BufferSize, int SamplesPerSec, int Channels, int BitsPerSample); 

// {799485B3-0DA1-4F74-90E2-5684C9CD949B}
DEFINE_GUID(IID_IDatasteadRTSPSampleCallback, 0x799485b3, 0xda1, 0x4f74, 0x90, 0xe2, 0x56, 0x84, 0xc9, 0xcd, 0x94, 0x9b);
MIDL_INTERFACE("799485B3-0DA1-4F74-90E2-5684C9CD949B")
IDatasteadRTSPSampleCallback : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE SetRawSampleCallback(DatasteadRTSP_RawSampleCallback SampleCallback, void *Sender) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetVideoRGBSampleCallback(DatasteadRTSP_VideoSampleCallback SampleCallback, void *Sender) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetAudioPCMSampleCallback(DatasteadRTSP_AudioSampleCallback SampleCallback, void *Sender) = 0;
};

// {845F8BAF-A774-4C46-A17A-F037613B9FC2}
DEFINE_GUID(IID_IDatasteadRTSPSampleCallback2, 0x845f8baf, 0xa774, 0x4c46, 0xa1, 0x7a, 0xf0, 0x37, 0x61, 0x3b, 0x9f, 0xc2);
MIDL_INTERFACE("845F8BAF-A774-4C46-A17A-F037613B9FC2")
IDatasteadRTSPSampleCallback2 : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE SetVideoRGBOverlayCallback(DatasteadRTSP_VideoSampleCallback SampleCallback, void *Sender) = 0;
};

