type

  IDatasteadRTSPSourceConfig = interface(IUnknown)
    ['{D7557B82-3FA4-4F4F-B7CF-96108202E4AF}']
     function GetBool   (ParamID: POLESTR;  out Value: Boolean): HRESULT; stdcall;
     function GetDouble (ParamID: POLESTR;  out Value: Double): HRESULT; stdcall;
     function GetInt    (ParamID: POLESTR;  out Value: LongInt): HRESULT; stdcall;
     function GetStr    (ParamID: POLESTR;  out Value: POLESTR): HRESULT; stdcall;

     function SetBool   (ParamID: POLESTR;  Value: Boolean): HRESULT; stdcall;
     function SetDouble (ParamID: POLESTR;  Value: Double): HRESULT; stdcall;
     function SetInt    (ParamID: POLESTR;  Value: LongInt): HRESULT; stdcall;
     function SetStr    (ParamID: POLESTR;  Value: POLESTR): HRESULT; stdcall;

     function Action    (ActionID: POLESTR; Value: POLESTR): HRESULT; stdcall;
  end;

  IDatasteadRTSPSourceConfig2 = interface(IDatasteadRTSPSourceConfig)
    ['{932C369A-3335-45BB-B5F4-A6CF77F9B40C}']
     function GetIntPtr    (ParamID: POLESTR;  out Value: NativeInt): HRESULT; stdcall;
  end;

  IDatasteadRTSPSourceConfig3 = interface(IDatasteadRTSPSourceConfig2)
    ['{6FCA28BE-7F96-467A-BB08-0611FC8162B7}']
     function GetInt64    (ParamID: POLESTR;  out Value: int64): HRESULT; stdcall;
     function SetInt64    (ParamID: POLESTR;  Value: int64): HRESULT; stdcall;
  end;

const
   RTSP_Action_OpenURL                             = 'RTSP_Action_OpenURL';
   RTSP_Action_OpenURLAsync                        = 'RTSP_Action_OpenURLAsync';
   RTSP_Action_GetONVIFSnapshot                    = 'RTSP_Action_GetONVIFSnapshot';
   RTSP_Action_GetONVIFSnapshotAsync               = 'RTSP_Action_GetONVIFSnapshotAsync';
   RTSP_Action_RecordToNewFileNow                  = 'RTSP_Action_RecordToNewFileNow';
   RTSP_Action_CancelPendingConnection             = 'RTSP_Action_CancelPendingConnection';
   RTSP_Action_PauseURL                            = 'RTSP_Action_PauseURL';
   RTSP_Action_ResumeURL                           = 'RTSP_Action_ResumeURL';
   RTSP_Action_PauseRecording                      = 'RTSP_Action_PauseRecording';
   RTSP_Action_ResumeRecording                     = 'RTSP_Action_ResumeRecording';
   RTSP_Action_CaptureFrame                        = 'RTSP_Action_CaptureFrame';
   RTSP_Action_UpdateDuration                      = 'RTSP_Action_UpdateDuration';

   RTSP_Source_RecordingFileName_str               = 'RTSP_Source_RecordingFileName_str';
   RTSP_Source_RecordingBacktimedStartSeconds_int  = 'RTSP_Source_RecordingBacktimedStartSeconds_int';
   RTSP_Source_PlayableWhileRecording_int          = 'RTSP_Source_PlayableWhileRecording_int';
   RTSP_Source_ContinuousRecording_bool            = 'RTSP_Source_ContinuousRecording_bool';
   RTSP_Source_MaxAnalyzeDuration_int              = 'RTSP_Source_MaxAnalyzeDuration_int';
   RTSP_Source_AutoReconnect_bool                  = 'RTSP_Source_AutoReconnect_bool';
   RTSP_Source_NoTranscoding_bool                  = 'RTSP_Source_NoTranscoding_bool';
   RTSP_Source_DeviceLostTimeOut_int               = 'RTSP_Source_DeviceLostTimeOut_int';
   RTSP_Source_BufferDuration_int                  = 'RTSP_Source_BufferDuration_int';
   RTSP_Source_LowDelay_int                        = 'RTSP_Source_LowDelay_int';
   RTSP_Source_SampleDeliveryMode_int              = 'RTSP_Source_SampleDeliveryMode_int';
   RTSP_Source_ConnectionTimeOut_int               = 'RTSP_Source_ConnectionTimeOut_int';
   RTSP_Source_RTSPTransport_int                   = 'RTSP_Source_RTSPTransport_int';
   RTSP_Source_RTSPRange_str                       = 'RTSP_Source_RTSPRange_str';
   RTSP_Source_Format_str                          = 'RTSP_Source_Format_str';
   RTSP_Source_FrameRate_double                    = 'RTSP_Source_FrameRate_double';
   RTSP_Source_AverageTimePerFrame100ns_int        = 'RTSP_Source_AverageTimePerFrame100ns_int';
   RTSP_Source_DurationMs_Int                      = 'RTSP_Source_DurationMs_int';
   RTSP_Source_Duration100ns_int64                 = 'RTSP_Source_Duration100ns_int64';
   RTSP_Source_VideoSize_str			               = 'RTSP_Source_VideoSize_str';
   RTSP_Source_VideoCodec_str			               = 'RTSP_Source_VideoCodec_str';
   RTSP_Source_AuthUser_str                        = 'RTSP_Source_AuthUser_str';
   RTSP_Source_AuthPassword_str                    = 'RTSP_Source_AuthPassword_str';
   RTSP_Source_StreamInfo_str                      = 'RTSP_Source_StreamInfo_str';
   RTSP_Source_StartTime_int                       = 'RTSP_Source_StartTime_int';
   RTSP_Source_Threads_int                         = 'RTSP_Source_Threads_int';
   RTSP_Source_IsURLConnected_bool                 = 'RTSP_Source_IsURLConnected_bool';
   RTSP_Source_GetAudioDevices_str                 = 'RTSP_Source_GetAudioDevices_str';
   RTSP_Source_SetAudioDevice_str                  = 'RTSP_Source_SetAudioDevice_str';
   RTSP_Source_GetURL_str                          = 'RTSP_Source_GetURL_str';

   RTSP_ONVIF_LastJPEGSnapshotBuffer_intptr        = 'RTSP_ONVIF_LastJPEGSnapshotBuffer_intptr';
   RTSP_ONVIF_LastJPEGSnapshotSize_int             = 'RTSP_ONVIF_LastJPEGSnapshotSize_int';

   RTSP_VideoStream_Enabled_bool                   = 'RTSP_VideoStream_Enabled_bool';
   RTSP_VideoStream_Synchronized_bool              = 'RTSP_VideoStream_Synchronized_bool';
   RTSP_VideoStream_Recorded_bool                  = 'RTSP_VideoStream_Recorded_bool';
   RTSP_VideoStream_Index_int                      = 'RTSP_VideoStream_Index_int';
   RTSP_VideoStream_PinFormat_str                  = 'RTSP_VideoStream_PinFormat_str';
   RTSP_VideoStream_Width_int                      = 'RTSP_VideoStream_Width_int';
   RTSP_VideoStream_Height_int                     = 'RTSP_VideoStream_Height_int';
   RTSP_VideoStream_TopDown_bool                   = 'RTSP_VideoStream_TopDown_bool';
   RTSP_VideoStream_FrameRateMax_double            = 'RTSP_VideoStream_FrameRateMax_double';
   RTSP_VideoStream_Filter_str                     = 'RTSP_VideoStream_Filter_str';
   RTSP_VideoStream_HWAcceleration_int             = 'RTSP_VideoStream_HWAcceleration_int';
   RTSP_VideoStream_Deinterlacing_int              = 'RTSP_VideoStream_Deinterlacing_int';
   RTSP_VideoStream_ConfigureTextOverlay_str       = 'RTSP_VideoStream_ConfigureTextOverlay_str';
   RTSP_VideoStream_ConfigureHueBrightSat_str      = 'RTSP_VideoStream_ConfigureHueBrightSat_str';

   RTSP_AudioStream_Enabled_bool                   = 'RTSP_AudioStream_Enabled_bool';
   RTSP_AudioStream_Recorded_bool                  = 'RTSP_AudioStream_Recorded_bool';
   RTSP_AudioStream_Index_int                      = 'RTSP_AudioStream_Index_int';
   RTSP_AudioStream_Filter_str                     = 'RTSP_AudioStream_Filter_str';
   RTSP_AudioStream_Volume_int                     = 'RTSP_AudioStream_Volume_int';

   RTSP_FrameCapture_Width_int                     = 'RTSP_FrameCapture_Width_int';
   RTSP_FrameCapture_Height_int                    = 'RTSP_FrameCapture_Height_int';
   RTSP_FrameCapture_Time_int                      = 'RTSP_FrameCapture_Time_int';
   RTSP_FrameCapture_FileName_str                  = 'RTSP_FrameCapture_FileName_str';

   RTSP_CurrentRecording_FileSizeKb_int            = 'RTSP_CurrentRecording_FileSizeKb_int';
   RTSP_CurrentRecording_ClipDurationMs_int        = 'RTSP_CurrentRecording_ClipDurationMs_int';
   RTSP_CurrentRecording_VideoFrameCount_int       = 'RTSP_CurrentRecording_VideoFrameCount_int';
   RTSP_CurrentRecording_FileName_str              = 'RTSP_CurrentRecording_FileName_str';

   RTSP_LastRecorded_FileSizeKb_int                = 'RTSP_LastRecorded_FileSizeKb_int';
   RTSP_LastRecorded_ClipDurationMs_int            = 'RTSP_LastRecorded_ClipDurationMs_int';
   RTSP_LastRecorded_VideoFrameCount_int           = 'RTSP_LastRecorded_VideoFrameCount_int';
   RTSP_LastRecorded_FileName_str                  = 'RTSP_LastRecorded_FileName_str';

   RTSP_Dest_URL_str                               = 'RTSP_Dest_URL_str';
   RTSP_Dest_Video_BitRate_int                     = 'RTSP_Dest_Video_BitRate_int';
   RTSP_Dest_Video_Quality_int                     = 'RTSP_Dest_Video_Quality_int';
   RTSP_Dest_Video_KeyFrameInterval_int            = 'RTSP_Dest_Video_KeyFrameInterval_int';

   RTSP_Filter_Version_int                         = 'RTSP_Filter_Version_int';
   RTSP_Filter_Build_int                           = 'RTSP_Filter_Build_int';
   RTSP_Filter_LicenseKey_str                      = 'RTSP_Filter_LicenseKey_str';

   /// EC_USER = $8000; // defined in DirectShow, uncomment this line if you get an EC_USER undeclared error
   EC_RTSPNOTIFY = EC_USER + $4000;
   EC_RTSP_PARAM1_DISKFULL                       =  1;
   EC_RTSP_PARAM1_DEVICELOST_RECONNECTING        =  3;
   EC_RTSP_PARAM1_DEVICELOST_RECONNECTED         =  4;
   EC_RTSP_PARAM1_RECORDTONEWFILE_COMPLETED      =  5;
   EC_RTSP_PARAM1_OPENURLASYNC_CONNECTION_RESULT =  6;
   EC_RTSP_PARAM1_FRAME_CAPTURE_SUCCEEDED        =  7;
   EC_RTSP_PARAM1_FRAME_CAPTURE_FAILED           =  8;
   EC_RTSP_PARAM1_ONVIF_SNAPSHOT_SUCCEEDED       =  9;
   EC_RTSP_PARAM1_ONVIF_SNAPSHOT_FAILED          = 10;
   EC_RTSP_PARAM1_DURATION_UPDATED               = 11;

type
  TOpenURLAsyncCallback = procedure (Sender: Pointer; CustomParam: Pointer; Result: HRESULT); stdcall;

  IDatasteadRTSPSourceCallbackConfig = interface(IUnknown)
    ['{58D66E77-B19C-4F9A-8B47-DFE1CA87B642}']
     function SetAsyncOpenURLCallback (CallbackFunctionPtr: TOpenURLAsyncCallback; Sender: pointer; CustomParam: Pointer): HRESULT; stdcall;
  end;

  TDatasteadRTSP_RawSampleCallback = procedure (Sender: Pointer; StreamNumber: LongInt; CodecName: POLESTR; SampleTime_Absolute: int64; SampleTime_Relative: int64; Buffer: pBYTE; BufferSize: LongInt; InfoString: POLESTR); stdcall;
  TDatasteadRTSP_VideoSampleCallback = procedure (Sender: Pointer; SampleTime_Absolute: int64; SampleTime_Relative: int64; Buffer: pBYTE; BufferSize: LongInt; VideoWidth, VideoHeight, BitCount, Stride: LongInt); stdcall;
  TDatasteadRTSP_AudioSampleCallback = procedure (Sender: Pointer; SampleTime_Absolute: int64; SampleTime_Relative: int64; Buffer: pBYTE; BufferSize: LongInt; SamplesPerSec, Channels, BitsPerSample: LongInt); stdcall;

  IDatasteadRTSPSampleCallback = interface(IUnknown)
    ['{799485B3-0DA1-4F74-90E2-5684C9CD949B}']
     function SetRawSampleCallback (SampleCallback: TDatasteadRTSP_RawSampleCallback; Sender: Pointer): HRESULT; stdcall;
     function SetVideoRGBSampleCallback (SampleCallback: TDatasteadRTSP_VideoSampleCallback; Sender: Pointer): HRESULT; stdcall;
     function SetAudioPCMSampleCallback (SampleCallback: TDatasteadRTSP_AudioSampleCallback; Sender: Pointer): HRESULT; stdcall;
  end;

  IDatasteadRTSPSampleCallback2 = interface(IDatasteadRTSPSampleCallback)
    ['{845F8BAF-A774-4C46-A17A-F037613B9FC2}']
     function SetVideoRGBOverlayCallback (SampleCallback: TDatasteadRTSP_VideoSampleCallback; Sender: Pointer): HRESULT; stdcall;
  end;




